
PAGE  59,132

;
;								         
;                             DUMPALL                                  
;     Grabs screen on F12 pressed. Fixes on INT 09h.                   
;	(c) Stas Levitsky, 1992 					 
;								         
;

psp_cmd_tail	equ	81h

seg_a		segment	byte public
		assume	cs:seg_a, ds:seg_a
		org	100h

START::         jmp     loc_10
                db      10 dup(0)
;
;
;			INT 09h External Interrupt
;
;

int_09h_entry	proc	far
		cli
                pushf
		db	60h
		push	ds
		push	es
		db	0E4h, 60h
		cmp	al,58h		;; F12 ?
                je      F12PRESS        ;; No -> old INT 09h
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
JMP_OLD9::
		pop	es
		pop	ds
		db	61h
		popf
		sti
		db	0EAh   ;; Jmp to old INT 09h
INT09OFF        dw      0000h
INT09SEG        dw      0000h
data_9		dd	00024h
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
F12PRESS::      db      0E4h, 61h, 8Ah, 0E0h, 0Ch, 80h,0E6h, 61h, 86h,0E0h
		db	0E6h, 61h,0FAh,0B0h, 20h, 0E6h, 20h,0FBh, 0Eh, 1Fh

		mov	ax,0FF09h
		int	12h             ;; CALL CRACK ENTRY

		pop	es
		pop	ds
		db	61h
		popf
		sti
		iret

int_09h_entry	endp

;
;
;			INT 21h External Interrupt
;                       FIXes changing INTs: 09h, 12h, 21h
;
;

int_21h_entry	proc	far
                pushf
		cli
		push	si
		push	ds
		lds	si,cs:data_9		; Load 32 bit ptr
		cmp	word ptr [si],10Dh
                je      LOC_7
		push	ax
		lodsw				; String [si] to ax
                mov     cs:INT09OFF,ax
		lodsw				; String [si] to ax
                mov     cs:INT09SEG,ax
		mov	word ptr [si-4],10Dh
		mov	[si-2],cs
		pop	ax

LOC_7::         pop     ds
		pop	si
                sti

		cmp	ax,2521h
		je	SET_21
		cmp	ax,3521h
		je	GET_21
		cmp	ax,2509h
                je      SET_09
		cmp	ax,3509h
                je      GET_09
                cmp     ax,2512h
                je      SET_12
                cmp     ax,3512h
                je      GET_12
		jmp	OLD21INT

SET_09::        mov     cs:INT09SEG,ds
                mov     cs:INT09OFF,dx
                popf
                iret
GET_09::        mov     es,cs:INT09SEG
                mov     bx,cs:INT09OFF
                popf
                iret

SET_12::        mov     cs:INT12SEG,ds
                mov     cs:INT12OFF,dx
                popf
                iret
GET_12::        mov     es,cs:INT12SEG
                mov     bx,cs:INT12OFF
                popf
                iret

SET_21::        mov     cs:INT21SEG,ds
                mov     cs:INT21OFF,dx
                popf
                iret
GET_21::        mov     es,cs:INT21SEG
                mov     bx,cs:INT21OFF
                popf
                iret

OLD21INT::	popf
		db	0EAh    ;; Jmp to Old INT 21h
INT21OFF        dw      0000h   ;; Writes here OFFSET
INT21SEG        dw      0000h   ;; Writes here SEG

int_21h_entry	endp

;
;
;                       INT 12h (WORK) External Interrupt
;			To call: INT 12h, AX=0FF09h
;			To ask : INT 12h, AX=0FF19h
;
;

CRACK_ENTRY     proc    far		;; INT 12h, AX=0FF09h
                cli
                cmp     ax,0FF09h
                je      WORK
                cmp     ax,0FF19h
                je      ASK_INST

OLD12INT:       sti
		db	0EAh
INT12OFF        dw      0000h
INT12SEG        dw      0000h

ASK_INST::      mov     ax,"09"
                sti
                iret

WORK::
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		cmp	cs:LETTER1,"z"
		je	NEXT_L
		inc     cs:LETTER1	;; - dump-a@ -> dump-b@
		jmp	OPEN
NEXT_L::	inc	cs:LETTER2	;; INC next @
		mov	cs:LETTER1,"a"
OPEN::		mov	dx,OFFSET PATH
		xor	cx,cx
		mov	ah,3ch
		int	21h      ;; Open file
                mov     cs:HANDLE,ax

                mov dx,OFFSET PAL
                xor bx,bx
                mov cx,0100h    ;; 256 colors

                mov ax,cs
                mov es,ax
                mov ax,1017h
                int 10h         ;; Saves Palette to Buffer. es = seg PAL !!!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ah,62h
int 21h
add bx,3000h
mov es,bx
mov bx,offset BYTES

mov     ax,es:[996Fh]
mov     cs:[bx+0],ax
add     word ptr es:[996Fh],14

mov     ax,es:[9971h]
mov     cs:[bx+2],ax
add     word ptr es:[9971h],14

mov     ax,es:[9973h]
mov     cs:[bx+4],ax
add     word ptr es:[9973h],14

mov     ax,es:[9975h]
mov     cs:[bx+6],ax
add     word ptr es:[9975h],14

mov     ax,es:[9977h]
mov     cs:[bx+8],ax
add     word ptr es:[9977h],14

mov     ax,es:[9979h]
mov     cs:[bx+10],ax
add     word ptr es:[9979h],14

mov     ax,es:[997Bh]
mov     cs:[bx+12],ax
add     word ptr es:[997Bh],14

mov     ax,es:[997Dh]
mov     cs:[bx+14],ax
add     word ptr es:[997Dh],14

mov     ax,es:[997Fh]
mov     cs:[bx+16],ax
add     word ptr es:[997Fh],14

mov     ax,es:[9981h]
mov     cs:[bx+18],ax
add     word ptr es:[9981h],14

mov     ax,es:[9983h]
mov     cs:[bx+20],ax
add     word ptr es:[9983h],14

mov     ax,es:[9985h]
mov     cs:[bx+22],ax
add     word ptr es:[9985h],14

mov     ax,es:[9987h]
mov     cs:[bx+24],ax
add     word ptr es:[9987h],14

mov     ax,es:[9989h]
mov     cs:[bx+26],ax
add     word ptr es:[9989h],14
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                mov bx,cs:HANDLE
                mov dx,OFFSET RIX ; Saves form "RIX3.."
                mov cx,778
                mov ah,40h
                int 21h         ;; Saves Palette to file

                mov cx,64000	;; 320x200
                mov ax,0A000h
                mov ds,ax
                xor dx,dx       ;; 0A000:0000
                mov ah,40h
                int 21h         ;; Save screen

		mov cx,28
		mov ax,cs
		mov ds,ax
                mov dx,offset BYTES     ;; Save BUFFER
		mov ah,40h
		int 21h

                mov     ah,3Eh          ;  Close file, bx=file handle
                int     21h
ERROR::
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                sti
                iret
RIX             db	"RIX3@",01,0C8h,00,0AFh,00
PAL		db	799 dup("!")
BYTES		db	30 dup(0)
HANDLE		dw	0

PATH            db	"dump-"
LETTER1		db	"@"
LETTER2		db	"@.sci",0
Q		db	10 dup(0)      ;; Shows end of RESIDENT PART
CRACK_ENTRY     endp

;
;
;                       INSTALL Point
;
;

LOC_10::
		mov	ah,9
		mov	dx,offset TEXT
		int	21h

                mov     ax,0FF19h   ;; Allready Resident ?
                int     12h
		cmp	ax,"09"
;		je	ALLREADY09	;; Many INSTALLS

		mov	ah,9
		mov	dx,offset INST
		int	21h

                mov     ax,3512h
                int     21h                     ; Get intrpt vector al in es:bx
                mov     INT12OFF,bx
                mov     INT12SEG,es
		cli
                mov     ax,0
                mov     es,ax
                mov     es:[00048h],offset CRACK_ENTRY
                mov     es:[0004Ah],cs          ; Set MY vector INT 12h

                mov     ax,3509h
                int     21h                     ; Get intrpt vector al in es:bx
                mov     INT09OFF,bx
                mov     INT09SEG,es
		cli
		mov	ax,0
		mov	es,ax
                mov     es:[00024h],offset INT_09h_ENTRY
                mov     es:[00026h],cs          ; Set MY vector INT 09h

                mov     ax,3521h
                int     21h                     ; Get intrpt vector al in es:bx
                mov     INT21OFF,bx
                mov     INT21SEG,es
		cli
		mov	ax,0
		mov	es,ax
                mov     es:[00084h],offset INT_21h_ENTRY
                mov     es:[00086h],cs          ; Set MY vector INT 21h
                sti

                mov     dx,offset Q             ; Terminate & stay resident
                int     27h                     ;  dx=offset last byte+1, cs=PSP

ALLREADY09:	mov	ah,09h
		mov	dx,OFFSET AINST
		int	21h
		ret

TEXT            db 10,"Ϳ",10,13
                db    " -======= DUMPALL (c) Stas Levitsky, 1992 ========- ",10,13
                db    "           (FIXes on INT 09) Many INSTALLS possible ",10,13
                db    "                                                    ",10,13
                db    "          Press F12 to GRAB SCREEN                  ",10,13
		db    " Created Files: dump-??.sci                         ",10,13
		db    " Maximum number of 676 files can be writen.         ",10,13
                db    "",10,13,"$"

INST		db "Installed Ok.",0ah,0dh,"$"
AINST		db "Allready Resident! No action taken.",10,13,"$"

seg_a		ends

		end	start
